//I have plans for more -Love Xenos109

deActivatePackage(XCoins);
package XCoins
{
  function XCoins_Reset(%client) 
  {
    %client.XCoins = 0;
    XCoins_Save(%client);
  }
  function XCoins_Save(%client) 
  {
    if(isObject(%client)) 
    {
      if(%client.XCoins_Loaded == 1) 
      {
        %file = new fileObject();
        %file.openForWrite("config/server/Coins/" @ %client.bl_id @ ".cs");
        %file.writeLine("FindClientByBL_ID(" @ %client.bl_id @ ").XCoins=" @ %client.XCoins @ ";");
        %file.close();
        %file.delete();
      } 
      else 
      {
        echo("[WARNING] " @ %client.getPlayerName() @ " isn't loaded, save aborted for safety");
      }
    } 
    else 
    {
      echo("[WARNING] Save attempted on non-existent client, save aborted for safety");
    }
  }
  function XCoins_Load(%client) 
  {
    exec("config/server/Coins/" @ %client.bl_id @ ".cs");
    %client.XCoins_Loaded = 1;
  }
  function XCoins_Tick() 
  {
    if($XCoins::Tick)
      cancel($XCoins::Tick);
    
    for(%i = 0;%i < ClientGroup.getCount();%i++) 
    {
      %client = ClientGroup.getObject(%i);
      XCoins_Save(%client);
      %client.DisplayCoins();
    }
    
    $XCoins::Tick = schedule(5000, 0, "XCoins_Tick");
  }
  function GameConnection::DisplayCoins(%client)
  {
    %coins = %client.XCoins;
    %font = "<font:verdana bold:20><just:right>";
    %color1 = "\c6";
    %color2 = "\c3";
    
    commandToClient(%client,'bottomPrint',%font @ %color1 @ "Coins: " @ %color2 @ %coins SPC "",0,true);
  }
  function gameConnection::onClientEnterGame(%client)
  {
    XCoins_Load(%client);
    %client.DisplayCoins();
    Parent::onClientEnterGame(%client);
  }
  function gameConnection::onClientLeaveGame(%client)
  {
    XCoins_Save(%client);
    %client.player.delete();
    Parent::onClientLeaveGame(%client);
  }
  function fxDTSBrick::onPlant(%brick)
  {
	parent::onPlant(%brick);
	
	if(%brick.client.isAdmin)
	{
		%brick.isAdmin = true;
	}
  }
  function Armor::onCollision(%this, %obj, %col, %thing, %other)
	{
		if(%col.getDatablock().getName() $= "coinItem")
		{
			if(isObject(%obj.client))
			{
				if(isObject(%col))
				{
					%obj.client.XCoins += %col.value;
					%suf = "s";
					if(%col.value <= 1)
						%suf = "";
					
					messageClient(%obj.client, '', "\c6You have picked up \c3" @ %col.value SPC "\c6coin" @ %suf @ "!");
					
					%obj.client.DisplayCoins();
					%col.canPickup = false;
					%col.delete();
				}
				else
				{
					%col.delete();
					MissionCleanup.remove(%col);
				}
			}
		}
		
		if(isObject(%col))
			parent::onCollision(%this, %obj, %col, %thing, %other);
	}
};
activatePackage(XCoins);

function serverCmdBuy(%client,%choice)
{
  if(!%client.XCoinRequest)
  {
    messageClient(%client,'',"<font:verdana bold:20>\c6You don't have any pending requests!");
    return;
  }
  
  switch$(%choice)
  {
    case "yes":
      
      if(!(%client.XCoins >= %client.XCoinRequestAmount))
      {
        messageClient(%client,'',"<font:verdana bold:20>\c6You cannot afford this request!");
        return;
      }
      
      messageClient(%client,'',"<font:verdana bold:20>\c6You have \c3accepted \c6the request of \c3" @ %client.XCoinRequestAmount @ " \c6Coins!");
      %client.XCoins -= %client.XCoinRequestAmount;
      %client.XCoinRequestBrick.TransferAccept(%client);
      %client.XCoinRequest = false;
      %client.XCoinRequestAmount = 0;
      %client.XCoinRequestBrick = 0;
      %client.DisplayCoins();
      
    case "no":
      
      messageClient(%client,'',"<font:verdana bold:20>\c6You have \c3declined \c6the request of \c3" @ %client.XCoinRequestAmount @ " \c6Coins!");
      %client.XCoinRequestBrick.TransferDecline(%client);
      %client.XCoinRequest = false;
      %client.XCoinRequestAmount = 0;
      %client.XCoinRequestBrick = 0;
      %client.DisplayCoins();
      
    default:
      
      messageClient(%client,'',"<font:verdana bold:20>\c6Say \c3/buy yes \c6to accept, and \c3/buy no \c6to decline!");
      
  }
}
//

function fxDTSBrick::spawnCoins(%this, %amt)
{
	if(%this.isAdmin)
	{
		if(!%amt)
			return;
		
		%location1 = getword(%this.getTransform(),0) SPC getword(%this.getTransform(),1);
		%location2 = getwords(%this.getTransform(),3);
		%height = getword(%this.getTransform(),2);
		%newCoin = new Item() 
		{
			datablock = coinItem;
			canPickup = false;
			rotate = 1;
			value = %amt;
		};
		%newCoin.setTransform(%location1 SPC %height+0.5 SPC %location2);
		%ranVel = getRandom(-8,8) SPC getRandom(-8,8) SPC getRandom(-8,8);
		%newCoin.setVelocity(%ranVel);
		MissionCleanup.add(%newCoin);
		%newCoin.setShapeName(%newCoin.value);
	}
}

function fxDTSBrick::spawnRandomCoins(%this, %amt1, %amt2)
{
	if(%this.isAdmin)
	{
		if(!%amt1 || !%amt2)
			return;
		
		%location1 = getword(%this.getTransform(),0) SPC getword(%this.getTransform(),1);
		%location2 = getwords(%this.getTransform(),3);
		%height = getword(%this.getTransform(),2);
		%amt = getRandom(%amt1,%amt2);
		%newCoin = new Item() 
		{
			datablock = coinItem;
			canPickup = false;
			rotate = 1;
			value = %amt;
		};
		%newCoin.setTransform(%location1 SPC %height+0.5 SPC %location2);
		%ranVel = getRandom(-8,8) SPC getRandom(-8,8) SPC getRandom(-8,8);
		%newCoin.setVelocity(%ranVel);
		MissionCleanup.add(%newCoin);
		%newCoin.setShapeName(%newCoin.value);
	}
}

datablock ItemData(coinItem)
{
	category = "Weapon";
	className = "Weapon";
	
	shapeFile = "./shapes/coin.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	
	doColorShift = true;
	colorShiftColor = "0 0 0";
	image = coinImage;
	candrop = true;
	canPickup = false;
};

datablock ShapeBaseImageData(coinImage)
{
	shapeFile = "./shapes/coin.dts";
	emap = true;
	
	doColorShift = true;
	colorShiftColor = coinItem.colorShiftColor;
	canPickup = false;
};

//
registerOutputEvent(fxDTSBrick, "spawnCoins", "int 1 25 1",1);
registerOutputEvent(fxDTSBrick, "spawnRandomCoins", "int 1 1000 1" TAB "int 1 1000 1",1);
registerOutputEvent(fxDTSBrick, "addCoins", "int 1 9000 1",1);
registerOutputEvent(fxDTSBrick, "removeCoins", "int 1 9000 1",1);
registerOutputEvent(fxDTSBrick, "requestCoins", "string 80 200" TAB "int 1 9000 1");
registerInputEvent(fxDTSBrick, "TransferAccept", "Self fxDTSBrick\tPlayer Player\tClient GameConnection\tMiniGame MiniGame",1);
registerInputEvent(fxDTSBrick, "TransferDecline", "Self fxDTSBrick\tPlayer Player\tClient GameConnection\tMiniGame MiniGame",1);

function fxDTSBrick::TransferAccept(%this, %client)
{
  $inputTarget_self = %this;
  $inputTarget_client = %client;
  $inputTarget_player = %client.player;
  $inputTarget_miniGame = getMiniGameFromObject(%this);
  %this.processInputEvent("TransferAccept", %client);
}

function fxDTSBrick::TransferDecline(%this, %client)
{
  $inputTarget_self = %this;
  $inputTarget_client = %client;
  $inputTarget_player = %client.player;
  $inputTarget_miniGame = getMiniGameFromObject(%this);
  %this.processInputEvent("TransferDecline", %client);
}

function fxDTSBrick::requestCoins(%this,%title,%amount,%client)
{
  if(%client.XCoinRequest)
  {
    messageClient(%client,'',"<font:verdana bold:20>\c6You already have a request pending!");
    return;
  }
  
  %request = %amount;
  if(!%request)
    return;
  
  %client.XCoinRequest = true;
  %client.XCoinRequestAmount = %request;
  %client.XCoinRequestBrick = %this;
  
  messageClient(%client,'',"<font:verdana bold:20>\c6Pay \c3" @ %request @ " \c6Coins for \c3" @ %title @ "\c6?");
  messageClient(%client,'',"<font:verdana bold:20>\c6Say \c3/buy \c6to get directions on choosing.");
}

function fxDTSBrick::addCoins(%this,%amount,%client)
{
  if(%this.isAdmin)
  {
    if(!%amount)
      return;
    if(!%client)
      return;
    
    %client.XCoins += %amount;
    %client.DisplayCoins();
  }
}

function fxDTSBrick::removeCoins(%this,%amount,%client)
{
  if(%this.isAdmin)
  {
    if(!%amount)
      return;
    if(!%client)
      return;
    
    %client.XCoins -= %amount;
    %client.DisplayCoins();
  }
}

XCoins_Tick();